<?php
class ControllerPaymentIpay88 extends Controller {
	private $error = array();

	public function index() {
		$version23 = false;
		if(version_compare(VERSION, '2.3') > 0) {
			$version23 = true;
		}

		$this->load->language('payment/ipay88');
		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			
			$this->model_setting_setting->editSetting('ipay88', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');
			
			if($version23) {
				$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', 'SSL'));
			} else {
				$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
			}
		}

		$data['heading_title'] = $this->language->get('heading_title');
        $data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_sim'] = $this->language->get('text_sim');
		$data['text_test'] = $this->language->get('text_test');
		$data['text_live'] = $this->language->get('text_live');
		$data['text_payment'] = $this->language->get('text_payment');
		$data['text_defered'] = $this->language->get('text_defered');
		$data['text_authenticate'] = $this->language->get('text_authenticate');
		$data['text_sandbox'] = $this->language->get('text_sandbox');
		$data['text_production'] = $this->language->get('text_production');
		
		$data['entry_title'] = $this->language->get('entry_title');
		$data['entry_desc'] = $this->language->get('entry_desc');
		$data['entry_vendor'] = $this->language->get('entry_vendor');
		$data['entry_password'] = $this->language->get('entry_password');
		$data['entry_store_city'] = $this->language->get('entry_store_city');
		$data['entry_store_state'] = $this->language->get('entry_store_state');
		$data['entry_store_postcode'] = $this->language->get('entry_store_postcode');
		$data['entry_test'] = $this->language->get('entry_test');
		$data['entry_transaction'] = $this->language->get('entry_transaction');
		$data['entry_order_status'] = $this->language->get('entry_order_status');		
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['sandbox_mode'] = $this->language->get('sandbox_mode');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['help_method_title']   	= $this->language->get('help_method_title');
		$data['help_description']   	= $this->language->get('help_description');
		$data['help_ipay88_action']		= $this->language->get('help_ipay88_action');

		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['title'])) {
			$data['error_title'] = $this->error['title'];
		} else {
			$data['error_title'] = '';
		}

 		if (isset($this->error['vendor'])) {
			$data['error_vendor'] = $this->error['vendor'];
		} else {
			$data['error_vendor'] = '';
		}

 		if (isset($this->error['password'])) {
			$data['error_password'] = $this->error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset($this->error['store_city'])) {
			$data['error_store_city'] = $this->error['store_city'];
		} else {
			$data['error_store_city'] = '';
		}

		if (isset($this->error['store_state'])) {
			$data['error_store_state'] = $this->error['store_state'];
		} else {
			$data['error_store_state'] = '';
		}

		if (isset($this->error['store_postcode'])) {
			$data['error_store_postcode'] = $this->error['store_postcode'];
		} else {
			$data['error_store_postcode'] = '';
		}

  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL')// 3 // ,
      		// 4 // 'separator' => false
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')// 5 // ,
      		// 6 // 'separator' => ' :: '
   		);

   		$data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/ipay88', 'token=' . $this->session->data['token'], 'SSL')// 7 // ,
      		// 8 // 'separator' => ' :: '
   		);
		
		$data['action'] = $this->url->link('payment/ipay88', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token']. '&type=payment', 'SSL');
		
		if($version23) {
			$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token']. '&type=payment', 'SSL');
		}
		
		
		if (isset($this->request->post['ipay88_title'])) {
			$data['ipay88_title'] = $this->request->post['ipay88_title'];
		} else {
			if($this->config->get('ipay88_title') == "")
			{
				$data['ipay88_title'] = "iPay88 Payment Gateway";
			}
			else
			{
				$data['ipay88_title'] = $this->config->get('ipay88_title');
			}
		}

		if (isset($this->request->post['ipay88_desc'])) {
			$data['ipay88_desc'] = $this->request->post['ipay88_desc'];
		} else {
			// if($this->config->get('ipay88_desc') == "")
			// {
			// 	$data['ipay88_desc'] = "* Please confirm order to go to payment page.";
			// }
			// else
			// {
				$data['ipay88_desc'] = $this->config->get('ipay88_desc');
			// }
		}

		if (isset($this->request->post['ipay88_vendor'])) {
			$data['ipay88_vendor'] = $this->request->post['ipay88_vendor'];
		} else {
			$data['ipay88_vendor'] = $this->config->get('ipay88_vendor');
		}
		
		if (isset($this->request->post['ipay88_password'])) {
			$data['ipay88_password'] = $this->request->post['ipay88_password'];
		} else {
			$data['ipay88_password'] = $this->config->get('ipay88_password');
		}

		if (isset($this->request->post['ipay88_store_city'])) {
			$data['ipay88_store_city'] = $this->request->post['ipay88_store_city'];
		} else {
			$data['ipay88_store_city'] = $this->config->get('ipay88_store_city');
		}

		if (isset($this->request->post['ipay88_store_state'])) {
			$data['ipay88_store_state'] = $this->request->post['ipay88_store_state'];
		} else {
			$data['ipay88_store_state'] = $this->config->get('ipay88_store_state');
		}

		if (isset($this->request->post['ipay88_store_postcode'])) {
			$data['ipay88_store_postcode'] = $this->request->post['ipay88_store_postcode'];
		} else {
			$data['ipay88_store_postcode'] = $this->config->get('ipay88_store_postcode');
		}
		
		if (isset($this->request->post['ipay88_order_status_id'])) {
			$data['ipay88_order_status_id'] = $this->request->post['ipay88_order_status_id'];
		} else {
			if($this->config->get('ipay88_order_status_id') == "")
			{
				$data['ipay88_order_status_id'] = 2; //Default = Processing
			}
			else
			{
				$data['ipay88_order_status_id'] = $this->config->get('ipay88_order_status_id'); 
			}
		} 

		$this->load->model('localisation/order_status');
		
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		$this->load->model('localisation/geo_zone');
										
		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if (isset($this->request->post['ipay88_status'])) {
			$data['ipay88_status'] = $this->request->post['ipay88_status'];
		} else {
			$data['ipay88_status'] = $this->config->get('ipay88_status');
		}

		if (isset($this->request->post['ipay88_sandbox'])) {
			$data['ipay88_sandbox'] = $this->request->post['ipay88_sandbox'];
		} else {
			$data['ipay88_sandbox'] = $this->config->get('ipay88_sandbox');
		}
		
		if (isset($this->request->post['ipay88_sort_order'])) {
			$data['ipay88_sort_order'] = $this->request->post['ipay88_sort_order'];
		} else {
			$data['ipay88_sort_order'] = $this->config->get('ipay88_sort_order');
		}

		if (isset($this->request->post['ipay88_paymentgroup_atm'])) {
			$data['ipay88_paymentgroup_atm'] = $this->request->post['ipay88_paymentgroup_atm'];
		} else {
			$data['ipay88_paymentgroup_atm'] = $this->config->get('ipay88_paymentgroup_atm');
		}

		if (isset($this->request->post['ipay88_paymentgroup_ewallet'])) {
			$data['ipay88_paymentgroup_ewallet'] = $this->request->post['ipay88_paymentgroup_ewallet'];
		} else {
			$data['ipay88_paymentgroup_ewallet'] = $this->config->get('ipay88_paymentgroup_ewallet');
		}

		if (isset($this->request->post['ipay88_paymentgroup_cc'])) {
			$data['ipay88_paymentgroup_cc'] = $this->request->post['ipay88_paymentgroup_cc'];
		} else {
			$data['ipay88_paymentgroup_cc'] = $this->config->get('ipay88_paymentgroup_cc');
		}

		/**
		 * Virtual Account
		 */
		if (isset($this->request->post['ipay88_atm_bca_va'])) {
			$data['ipay88_atm_bca_va'] = $this->request->post['ipay88_atm_bca_va'];
		} else {
			$data['ipay88_atm_bca_va'] = $this->config->get('ipay88_atm_bca_va');
		}

		if (isset($this->request->post['ipay88_atm_bni_va'])) {
			$data['ipay88_atm_bni_va'] = $this->request->post['ipay88_atm_bni_va'];
		} else {
			$data['ipay88_atm_bni_va'] = $this->config->get('ipay88_atm_bni_va');
		}

		if (isset($this->request->post['ipay88_atm_bri_va'])) {
			$data['ipay88_atm_bri_va'] = $this->request->post['ipay88_atm_bri_va'];
		} else {
			$data['ipay88_atm_bri_va'] = $this->config->get('ipay88_atm_bri_va');
		}

		if (isset($this->request->post['ipay88_atm_mandiri_va'])) {
			$data['ipay88_atm_mandiri_va'] = $this->request->post['ipay88_atm_mandiri_va'];
		} else {
			$data['ipay88_atm_mandiri_va'] = $this->config->get('ipay88_atm_mandiri_va');
		}

		if (isset($this->request->post['ipay88_atm_mandiri_atm'])) {
			$data['ipay88_atm_mandiri_atm'] = $this->request->post['ipay88_atm_mandiri_atm'];
		} else {
			$data['ipay88_atm_mandiri_atm'] = $this->config->get('ipay88_atm_mandiri_atm');
		}

		if (isset($this->request->post['ipay88_atm_permata_va'])) {
			$data['ipay88_atm_permata_va'] = $this->request->post['ipay88_atm_permata_va'];
		} else {
			$data['ipay88_atm_permata_va'] = $this->config->get('ipay88_atm_permata_va');
		}

		if (isset($this->request->post['ipay88_atm_maybank_va'])) {
			$data['ipay88_atm_maybank_va'] = $this->request->post['ipay88_atm_maybank_va'];
		} else {
			$data['ipay88_atm_maybank_va'] = $this->config->get('ipay88_atm_maybank_va');
		}

		if (isset($this->request->post['ipay88_atm_cimb_va'])) {
			$data['ipay88_atm_cimb_va'] = $this->request->post['ipay88_atm_cimb_va'];
		} else {
			$data['ipay88_atm_cimb_va'] = $this->config->get('ipay88_atm_cimb_va');
		}
		/**
		 * End of Virtual Account
		 */

		/**
		 * E-Wallet
		*/
		if (isset($this->request->post['ipay88_ewallet_ovo'])) {
			$data['ipay88_ewallet_ovo'] = $this->request->post['ipay88_ewallet_ovo'];
		} else {
			$data['ipay88_ewallet_ovo'] = $this->config->get('ipay88_ewallet_ovo');
		}

		if (isset($this->request->post['ipay88_ewallet_linkaja'])) {
			$data['ipay88_ewallet_linkaja'] = $this->request->post['ipay88_ewallet_linkaja'];
		} else {
			$data['ipay88_ewallet_linkaja'] = $this->config->get('ipay88_ewallet_linkaja');
		}

		if (isset($this->request->post['ipay88_ewallet_shopeepay'])) {
			$data['ipay88_ewallet_shopeepay'] = $this->request->post['ipay88_ewallet_shopeepay'];
		} else {
			$data['ipay88_ewallet_shopeepay'] = $this->config->get('ipay88_ewallet_shopeepay');
		}

		if (isset($this->request->post['ipay88_ewallet_dana'])) {
			$data['ipay88_ewallet_dana'] = $this->request->post['ipay88_ewallet_dana'];
		} else {
			$data['ipay88_ewallet_dana'] = $this->config->get('ipay88_ewallet_dana');
		}
		/**
		 * End of E-Wallet
		 */
		
		/**
		 * Credit Card
		 */
		if (isset($this->request->post['ipay88_cc_bca'])) {
			$data['ipay88_cc_bca'] = $this->request->post['ipay88_cc_bca'];
		} else {
			$data['ipay88_cc_bca'] = $this->config->get('ipay88_cc_bca');
		}

		if (isset($this->request->post['ipay88_cc_bca_auth'])) {
			$data['ipay88_cc_bca_auth'] = $this->request->post['ipay88_cc_bca_auth'];
		} else {
			$data['ipay88_cc_bca_auth'] = $this->config->get('ipay88_cc_bca_auth');
		}
		
		if (isset($this->request->post['ipay88_cc_bri'])) {
			$data['ipay88_cc_bri'] = $this->request->post['ipay88_cc_bri'];
		} else {
			$data['ipay88_cc_bri'] = $this->config->get('ipay88_cc_bri');
		}

		if (isset($this->request->post['ipay88_cc_cimb'])) {
			$data['ipay88_cc_cimb'] = $this->request->post['ipay88_cc_cimb'];
		} else {
			$data['ipay88_cc_cimb'] = $this->config->get('ipay88_cc_cimb');
		}

		if (isset($this->request->post['ipay88_cc_cimb_auth'])) {
			$data['ipay88_cc_cimb_auth'] = $this->request->post['ipay88_cc_cimb_auth'];
		} else {
			$data['ipay88_cc_cimb_auth'] = $this->config->get('ipay88_cc_cimb_auth');
		}

		if (isset($this->request->post['ipay88_cc_cimb_ipg'])) {
			$data['ipay88_cc_cimb_ipg'] = $this->request->post['ipay88_cc_cimb_ipg'];
		} else {
			$data['ipay88_cc_cimb_ipg'] = $this->config->get('ipay88_cc_cimb_ipg');
		}

		if (isset($this->request->post['ipay88_cc_danamon'])) {
			$data['ipay88_cc_danamon'] = $this->request->post['ipay88_cc_danamon'];
		} else {
			$data['ipay88_cc_danamon'] = $this->config->get('ipay88_cc_danamon');
		}

		if (isset($this->request->post['ipay88_cc_mandiri'])) {
			$data['ipay88_cc_mandiri'] = $this->request->post['ipay88_cc_mandiri'];
		} else {
			$data['ipay88_cc_mandiri'] = $this->config->get('ipay88_cc_mandiri');
		}

		if (isset($this->request->post['ipay88_cc_maybank'])) {
			$data['ipay88_cc_maybank'] = $this->request->post['ipay88_cc_maybank'];
		} else {
			$data['ipay88_cc_maybank'] = $this->config->get('ipay88_cc_maybank');
		}
		if (isset($this->request->post['ipay88_cc_gpn'])) {
			$data['ipay88_cc_gpn'] = $this->request->post['ipay88_cc_gpn'];
		} else {
			$data['ipay88_cc_gpn'] = $this->config->get('ipay88_cc_gpn');
		}
		if (isset($this->request->post['ipay88_cc_gpn'])) {
			$data['ipay88_cc_gpn'] = $this->request->post['ipay88_cc_gpn'];
		} else {
			$data['ipay88_cc_gpn'] = $this->config->get('ipay88_cc_gpn');
		}
		if (isset($this->request->post['ipay88_cc_unionpay'])) {
			$data['ipay88_cc_unionpay'] = $this->request->post['ipay88_cc_unionpay'];
		} else {
			$data['ipay88_cc_unionpay'] = $this->config->get('ipay88_cc_unionpay');
		}
		/**
		 * End of Credit Card
		*/

		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/ipay88.tpl', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/ipay88')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['ipay88_title']) {
			$this->error['title'] = $this->language->get('error_title');
		}  

		// if (!$this->request->post['ipay88_desc']) {
		// 	$this->error['desc'] = $this->language->get('error_desc');
		// }  
		
	   	if (!$this->request->post['ipay88_vendor']) {
			$this->error['vendor'] = $this->language->get('error_vendor');
		}        

		if (!$this->request->post['ipay88_password']) {
			$this->error['password'] = $this->language->get('error_password');
		}

		if (!$this->request->post['ipay88_store_city']) {
			$this->error['store_city'] = $this->language->get('error_store_city');
		}

		if (!$this->request->post['ipay88_store_state']) {
			$this->error['store_state'] = $this->language->get('error_store_state');
		}

		if (!$this->request->post['ipay88_store_postcode']) {
			$this->error['store_postcode'] = $this->language->get('error_store_postcode');
		}

		return !$this->error;
	}
}
?>