<?php
class ControllerPaymentIpay88 extends Controller {
	public function index() {
		$this->load->language('payment/ipay88');
		
		$data['button_confirm'] = $this->language->get('button_confirm');
		$data['button_back'] = $this->language->get('button_back');

    	$data['action'] = $this->url->link('payment/ipay88/paymentrequest', '', 'SSL');
		
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$data['TitleDesc'] = $this->config->get('ipay88_desc');

		$virtualAccount = array();
		$ewallet = array();
		$creditCard = array();

		$virtualAccount['key'] = 'Virtual Account';
		$virtualAccount['items'] = array();
		$ewallet['key'] = 'E-Wallet';
		$ewallet['items'] = array();
		$creditCard['key'] = 'Credit Card';
		$creditCard['items'] = array();

		if ($this->config->get('ipay88_atm_bca_va')) {
			array_push($virtualAccount['items'], array('name' => 'BCA', 'value' => $this->config->get('ipay88_atm_bca_va')));
		}
		if ($this->config->get('ipay88_atm_bni_va')) {
			array_push($virtualAccount['items'], array('name' => 'BNI', 'value' => $this->config->get('ipay88_atm_bni_va')));
		}
		if ($this->config->get('ipay88_atm_bri_va')) {
			array_push($virtualAccount['items'], array('name' => 'BRI', 'value' => $this->config->get('ipay88_atm_bri_va')));
		}
		if ($this->config->get('ipay88_atm_mandiri_va')) {
			array_push($virtualAccount['items'], array('name' => 'Mandiri', 'value' => $this->config->get('ipay88_atm_mandiri_va')));
		}
		if ($this->config->get('ipay88_atm_mandiri_atm')) {
			array_push($virtualAccount['items'], array('name' => 'Mandiri ATM', 'value' => $this->config->get('ipay88_atm_mandiri_atm')));
		}
		if ($this->config->get('ipay88_atm_permata_va')) {
			array_push($virtualAccount['items'], array('name' => 'Permata', 'value' => $this->config->get('ipay88_atm_permata_va')));
		}
		if ($this->config->get('ipay88_atm_maybank_va')) {
			array_push($virtualAccount['items'], array('name' => 'Maybank', 'value' => $this->config->get('ipay88_atm_maybank_va')));
		}
		if ($this->config->get('ipay88_atm_cimb_va')) {
			array_push($virtualAccount['items'], array('name' => 'CIMB', 'value' => $this->config->get('ipay88_atm_cimb_va')));
		}

		/**
		 * E-Wallet
		 */

		if ($this->config->get('ipay88_ewallet_ovo')) {
			array_push($ewallet['items'], array('name' => 'OVO', 'value' => $this->config->get('ipay88_ewallet_ovo')));
		}
		if ($this->config->get('ipay88_ewallet_linkaja')) {
			array_push($ewallet['items'], array('name' => 'LinkAja', 'value' => $this->config->get('ipay88_ewallet_linkaja')));
		}
		if ($this->config->get('ipay88_ewallet_shopeepay')) {
			array_push($ewallet['items'], array('name' => 'ShopeePay', 'value' => $this->config->get('ipay88_ewallet_shopeepay')));
		}
		if ($this->config->get('ipay88_ewallet_dana')) {
			array_push($ewallet['items'], array('name' => 'Dana', 'value' => $this->config->get('ipay88_ewallet_dana')));
		}

		/**
		 * Credit Card
		 */
		if ($this->config->get('ipay88_cc_bca')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB / Amex', 'value' => $this->config->get('ipay88_cc_bca')));
		}
		if ($this->config->get('ipay88_cc_bca_auth')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB / Amex', 'value' => $this->config->get('ipay88_cc_bca_auth')));
		}
		if ($this->config->get('ipay88_cc_bri')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB', 'value' => $this->config->get('ipay88_cc_bri')));
		}
		if ($this->config->get('ipay88_cc_cimb')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB', 'value' => $this->config->get('ipay88_cc_cimb')));
		}
		if ($this->config->get('ipay88_cc_cimb_auth')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB', 'value' => $this->config->get('ipay88_cc_cimb_auth')));
		}
		if ($this->config->get('ipay88_cc_cimb_ipg')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB', 'value' => $this->config->get('ipay88_cc_cimb_ipg')));
		}
		if ($this->config->get('ipay88_cc_danamon')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB', 'value' => $this->config->get('ipay88_cc_danamon')));
		}
		if ($this->config->get('ipay88_cc_mandiri')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard', 'value' => $this->config->get('ipay88_cc_mandiri')));
		}
		if ($this->config->get('ipay88_cc_maybank')) {
			array_push($creditCard['items'], array('name' => 'Visa / Mastercard / JCB', 'value' => $this->config->get('ipay88_cc_maybank')));
		}
		if ($this->config->get('ipay88_cc_gpn')) {
			array_push($creditCard['items'], array('name' => 'GPN', 'value' => $this->config->get('ipay88_cc_gpn')));
		}
		if ($this->config->get('ipay88_cc_unionpay')) {
			array_push($creditCard['items'], array('name' => 'UnionPay', 'value' => $this->config->get('ipay88_cc_unionpay')));
		}

		$data['ipay88_paymentgroup_atm'] = $this->config->get('ipay88_paymentgroup_atm');
		$data['ipay88_paymentgroup_ewallet'] = $this->config->get('ipay88_paymentgroup_ewallet');
		$data['ipay88_paymentgroup_cc'] = $this->config->get('ipay88_paymentgroup_cc');
		$data['ipay88_virtual_account'] = $virtualAccount;
		$data['ipay88_ewallet'] = $ewallet;
		$data['ipay88_credit_card'] = $creditCard;
		
		return $this->load->view('payment/ipay88', $data);
		
		$this->render();
	}

	public function paymentrequest()
	{
		$this->load->language('payment/ipay88');
		$this->document->setTitle("Payment");		
		$this->load->model('checkout/order');
		$data['column_left'] 	= $this->load->controller('common/column_left');
		$data['column_right'] 	= $this->load->controller('common/column_right');
		$data['content_top']	= $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] 		= $this->load->controller('common/footer');
		$data['header'] 		= $this->load->controller('common/header');
		$data['checkout_link'] = $this->url->link('checkout/checkout', '', true);
		
		date_default_timezone_set('Asia/Jakarta');

		$SandboxMode 	= $this->config->get('ipay88_sandbox');
		$order_info 	= $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$RefNo 			= "OC2" . date_create('now')->format('Ymd') . "-" . $this->session->data['order_id'];
		$MerchantKey 	= $this->config->get('ipay88_password');

		//PRODUCT
		$products = $this->cart->getProducts();

		$dataprod = [];
		foreach ($products as $product) {
			$dataprod[] = " " . $product['name'] . " x " . $product['quantity'];
		}

		$data['MerchantCode'] 	= $this->config->get('ipay88_vendor');
		$data['PaymentId'] 		= $this->request->post["payment_id"];
		$data['RefNo'] 			= $RefNo;
		$data['Currency'] 		= $order_info['currency_code'];
		$data['ProdDesc'] 		= implode(', ', $dataprod);
		$data['UserName'] 		= $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		$data['UserEmail'] 		= $order_info['email'];
		$data['UserContact'] 	= $order_info['telephone'];
		$data['Remark'] 		= sprintf($this->language->get('text_description'), date($this->language->get('date_format_short')), $this->session->data['order_id']);
		$data['Lang'] 			= "UTF-8";
		$data['ResponseURL'] 	= $this->url->link('payment/ipay88/callback', '', 'SSL');
		$data['BackendURL'] 	= $this->url->link('payment/ipay88/backendcallback', '', 'SSL');
		
		//$this->paymentRequestV1($order_info, $SandboxMode, $data, $MerchantKey, $products);

		// incase for future developement using API V2
		 $this->paymentRequestV2($order_info, $SandboxMode, $data, $MerchantKey, $products);
	}

	private function paymentRequestV1($order_info, $SandboxMode, $data, $MerchantKey, $products)
	{
		//HASH AMOUNT
		$total 			= $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$orderAmount	= number_format($total, 2, ".", "");
		$HashAmount 	= str_replace(".", "", str_replace(",", "", $orderAmount));

		//SIGNATURE
		$ipaySignature 	= "";

		$encrypt		= sha1($MerchantKey . $data['MerchantCode'] . $data['RefNo'] . $HashAmount . $data['Currency']);

		for ($i = 0; $i < strlen($encrypt); $i = $i + 2) {
			$ipaySignature .= chr(hexdec(substr($encrypt, $i, 2)));
		}

		$ipaySignature = base64_encode($ipaySignature);

		$url  		 = "https://payment.ipay88.co.id/epayment/entry.asp";

		if($SandboxMode == "1")
		{
			$url  	 = "https://sandbox.ipay88.co.id/epayment/entry.asp";
		}

		//iPay88 Params
		$data['Amount'] 		= $HashAmount;
		$data['Signature'] 		= $ipaySignature;
		$data['ipay88_action'] 	= $url;
		
		$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 1, "iPay88 Order Created, Waiting for Payment.", true);
		$this->response->setOutput($this->load->view('payment/ipay88_paymentrequestv1', $data));
	}
	
	private function paymentRequestV2($order_info, $SandboxMode, $data, $MerchantKey, $products)
	{
		$total = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

		//SIGNATURE
		$ipaySignature = hash('sha256', "||" . $MerchantKey . "||" . $data['MerchantCode'] . "||" . $data['RefNo'] . "||" . $total . "||" . $data['Currency'] . "||");

		$iproduct = 0;
		foreach ($products as $product) {
			$item_list[$iproduct]['id'] 		= $iproduct + 1;
			$item_list[$iproduct]['name'] 		= $product['name'];
			$item_list[$iproduct]['quantity'] 	= $product['quantity'];
			$item_list[$iproduct]['amount'] 	= $product['total'];
			$item_list[$iproduct]['type'] 		= $product['model'];
			$item_list[$iproduct]['url'] 		= $this->url->link('product/product', 'product_id=' . $product['product_id']);
			//$this->url->link('product/product', 'product_id=' . $product_id);
			$item_list[$iproduct]['ParentType'] = "SELLER";
			$item_list[$iproduct]['ParentId'] 	= $data['MerchantCode'];

			$iproduct = $iproduct + 1;
		}

		if ($this->cart->hasShipping()) {
			$shipping_methodcost = $this->session->data['shipping_method']['cost'];
			$item_list[$iproduct]['id'] 		= "shippingfee";
			$item_list[$iproduct]['name'] 		= "Shipping";
			$item_list[$iproduct]['quantity'] 	= 1;
			$item_list[$iproduct]['amount'] 	= $shipping_methodcost;
			$item_list[$iproduct]['type'] 		= "Shipping";
			$item_list[$iproduct]['url'] 		= $this->url->link('product/product', 'product_id=0');
			$item_list[$iproduct]['ParentType'] = "SELLER";
			$item_list[$iproduct]['ParentId'] 	= $data['MerchantCode'];
			
			$iproduct = $iproduct + 1;
		}
		
		$ShippingAddress = array(
			'FirstName'		=> $order_info['shipping_firstname'],
			'LastName'		=> $order_info['shipping_lastname'],
			'Address'		=> $order_info['shipping_address_1'] . ' ' . $order_info['shipping_address_2'],
			'City'			=> $order_info['shipping_city'],
			'State'			=> $order_info['shipping_zone'],
			'PostalCode'	=> $order_info['shipping_zone_id'],
			'Phone'			=> $order_info['telephone'],
			'CountryCode'	=> $order_info['shipping_iso_code_2']
		);

		$BillingAddress = array(
			'FirstName'		=> $order_info['payment_firstname'],
			'LastName'		=> $order_info['payment_lastname'],
			'Address'		=> $order_info['payment_address_1'] . ' ' . $order_info['payment_address_2'],
			'City'			=> $order_info['payment_city'],
			'State'			=> $order_info['payment_zone'],
			'PostalCode'	=> $order_info['payment_zone_id'],
			'Phone'			=> $order_info['telephone'],
			'CountryCode'	=> $order_info['payment_iso_code_2']
		);

		if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
			$base = $this->config->get('config_ssl');
		} else {
			$base = $this->config->get('config_url');
		}

		$split_config_owner = explode(" ", $this->config->get('config_owner'));
		$split_config_owner1 = $split_config_owner[0];

		$Sellers = array(
			'Id'			=>	$data['MerchantCode'],
			'Name'			=>	$this->config->get('config_name'),
			'Email'			=>	$this->config->get('config_email'),
			'Url'			=>  $base,
			'Address'		=>
			[
				'FirstName'		=>	$split_config_owner1,
				'LastName'		=>	str_replace($split_config_owner1 . ' ', '', $this->config->get('config_owner')),
				'Address'		=>	$this->config->get('config_address'),
				'City'			=>	$this->config->get('ipay88_store_city'),
				'State'			=>	$this->config->get('ipay88_store_state'),
				'PostalCode'	=>	$this->config->get('ipay88_store_postcode'),
				'Phone'			=>	$this->config->get('config_telephone'),
				'CountryCode'	=>	'ID'
			]
		);

		$ipay88_Obj = new stdClass();
		$ipay88_Obj->MerchantCode 				= $data['MerchantCode'];
		$ipay88_Obj->PaymentId 					= $data['PaymentId'];
		$ipay88_Obj->Currency 					= $data['Currency'];
		$ipay88_Obj->RefNo						= $data['RefNo'];
		$ipay88_Obj->Amount						= $total;
		$ipay88_Obj->ProdDesc					= $data['ProdDesc'];
		$ipay88_Obj->UserName					= $data['UserName'];
		$ipay88_Obj->UserEmail					= $data['UserEmail'];
		$ipay88_Obj->UserContact				= $data['UserContact'];
		$ipay88_Obj->Remark						= $data['Remark'];
		$ipay88_Obj->Lang						= $data['Lang'];
		$ipay88_Obj->ResponseURL				= $data['ResponseURL'];
		$ipay88_Obj->BackendURL					= $data['BackendURL'];
		$ipay88_Obj->Signature					= $ipaySignature;
		$ipay88_Obj->xfield1					= "";

		$ipay88_Obj->itemTransactions			= $item_list;
		$ipay88_Obj->ShippingAddress			= $ShippingAddress;
		$ipay88_Obj->BillingAddress				= $BillingAddress;
		$ipay88_Obj->APIVersion					= "2.0";

		$ipay88_Obj->Sellers				= array($Sellers);

		$ipay88_JSON = json_encode($ipay88_Obj, JSON_UNESCAPED_SLASHES);

		$url  		 = "https://payment.ipay88.co.id/ePayment/WebService/PaymentAPI/Checkout";

		if($SandboxMode == "1")
		{
			$url  	 = "https://sandbox.ipay88.co.id/ePayment/WebService/PaymentAPI/Checkout";
		}

		$options 	 = array(
			'http' 	=> array(
				'header'  	=> "Content-type: application/json\r\n",
				'method'  	=> 'POST',
				"timeout" => (float) 30.0,
				'content' 	=> $ipay88_JSON
			)
		);

		$context		= stream_context_create($options);

		$result 		= file_get_contents($url, false, $context);
		$jresult 		= json_decode($result, true);

		if ($result === FALSE) {
			$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 10, "iPay88 Payment Failed. Error Description: Payment Request Failed. Request: $url - $ipay88_JSON");

			$this->response->setOutput($this->load->view('payment/ipay88_failure', $data));
		} else {
			$jresult = json_decode($result, true);

			$status = "";
			$error_response = "";

			$status = $jresult['Code'];
			$error_response = $jresult['Message'];

			if ($status == "0") {
				$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 10, "iPay88 Payment Failed. Request: $url - $ipay88_JSON. Response Description: " . $error_response . ". " . print_r($result, true));

				$this->response->setOutput($this->load->view('payment/ipay88_failure', $data));
			} else {

				$rSignature 		= $jresult['Signature'];

				//iPay88 Params
				$data['Signature'] 		= $ipaySignature;

				$url  		 = "https://payment.ipay88.co.id/PG/";

				if($SandboxMode == "1")
				{
					$url  	 = "https://sandbox.ipay88.co.id/PG/";
				}

				
				$data['RedirectURL'] 	= $url;
				$data['CheckoutID'] 	= $jresult['CheckoutID'];

				$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 1, "iPay88 Order Created, Waiting for Payment.", true);
				$this->response->setOutput($this->load->view('payment/ipay88_paymentrequestv2', $data));
			}
		}
	}

	public function callback() 
	{
		header('Set-Cookie: ' . $this->config->get('session_name') . '=' . $this->session->getId() . '; SameSite=None; Secure');
		
		$this->load->language('payment/ipay88');
		$this->load->model('checkout/order');
		$this->document->setTitle($this->language->get('text_payment_title'));

		$data['column_left'] 	= $this->load->controller('common/column_left');
		$data['column_right'] 	= $this->load->controller('common/column_right');
		$data['content_top']	= $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] 		= $this->load->controller('common/footer');
		$data['header'] 		= $this->load->controller('common/header');
		$data['checkout_link']  = $this->url->link('checkout/checkout', '', true);
		$data['continue'] 		= $this->url->link('common/home');

		if (isset($_REQUEST['RefNo'])) {			
			$this->load->model('checkout/order');
			
			//Get reference number response
			$RefNo = $_REQUEST['RefNo'];
			$OrderNo = (explode('-', $_REQUEST['RefNo']))[1];
			$order_info = $this->model_checkout_order->getOrder($OrderNo);

			$sql = 'select comment from '.DB_PREFIX.'order_history where order_id = '.$order_info['order_id'].' order by date_added desc limit 1';
			$result = $this->db->query($sql);
			$isVA = false;

			if ($result) {
				$history = $result->row;
				$comment = explode("||", $history["comment"]);
				$status = trim($comment[0]);
				if (count($comment) == 3) { // get VA number
					$va = $comment[2];
					$isVA = true;
				}
			}

			if ($status == "Pending") {
				$data['heading_title'] = $this->language->get('payment_pending_title');

				if ($isVA) {
					if ($this->customer->isLogged()) {
						$data['text_message'] = sprintf($this->language->get('payment_pending_customer'), $va, $this->url->link('account/account', '', true), $this->url->link('account/order', '', true), $this->url->link('account/download', '', true), $this->url->link('information/contact'));
					} else {
						$data['text_message'] = sprintf($this->language->get('payment_pending_guest'), $va, $this->url->link('information/contact'));
					}
				} else {
					$data['text_message'] = $this->language->get('payment_pending_other');
				}

				$this->response->setOutput($this->load->view('payment/ipay88_pending', $data));
			} else if ($status == "Success") {
				$this->response->redirect($this->url->link('checkout/success', '', true));
			} else {
				$data['text_message'] = sprintf($history["comment"]);
				$this->response->setOutput($this->load->view('payment/ipay88_failure', $data));
			}
		} else {
			$this->response->redirect($this->url->link('common/home'));
		}
	}

	public function backendcallback() 
	{
		$this->load->language('payment/ipay88');
		$this->load->model('checkout/order');
		$this->document->setTitle($this->language->get('text_payment_title'));
		$ipay88response = file_get_contents('php://input');
	
		if ($ipay88response) {
			$ipay88response = json_decode($ipay88response);
			$RefNo = $ipay88response->RefNo;

			$OrderNo = (explode('-', $RefNo))[1];
			$order_info = $this->model_checkout_order->getOrder($OrderNo);

			//Get signature response
			$signature_response		= $ipay88response->Signature;

			//Generate signature
			$MerchantKey_response 	= $this->config->get('ipay88_password');
			$MerchantCode_response 	= $this->config->get('ipay88_vendor');
			$PaymentId_response		= $ipay88response->PaymentId;
			$HashAmount_response 	= $ipay88response->Amount;
			$Currency_response 		= $ipay88response->Currency;
			$Status_response 		= $ipay88response->TransactionStatus;

			$merchant_signature		= "";
			$total = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$merchant_signature = hash('sha256', "||" . $MerchantKey_response . "||" . $MerchantCode_response . "||".$PaymentId_response. "||" . $RefNo . "||" . $HashAmount_response . "||" . $Currency_response . "||".$Status_response."||");

			//Receive OK
			if ($Status_response == "1" && $merchant_signature == $signature_response) {
				if($order_info['order_status_id'] == 1) //Pending
				{
					$sql = 'delete from '.DB_PREFIX.'cart where customer_id =  ' . $order_info['customer_id'];
					$this->db->query($sql);
					
					$this->model_checkout_order->addOrderHistory($OrderNo, $this->config->get('ipay88_order_status_id'), "Success || iPay88 Payment Completed. Transaction Reference Number: " . $ipay88response->TransId . ".", true);
				}
				
				$this->response->setOutput($this->load->view('payment/ipay88_success_backend'));
			}

			//Pending
			else if (($Status_response == "3" || $Status_response == "6") && $merchant_signature == $signature_response)
			{
				$sql = 'delete from '.DB_PREFIX.'cart where customer_id =  ' . $order_info['customer_id'];
				$this->db->query($sql);

				$Status_message = $ipay88response->ErrDesc;
				$messageLog = "";

				if($ipay88response->AuthCode)
				{
					$messageLog = "Pending || [SYSTEM] iPay88 ATM Transfer Pending. ".$Status_message.". VA Number: ". $ipay88response->AuthCode.". Transaction Reference Number: " . $ipay88response->TransId." || ".$ipay88response->AuthCode;
				}
				else
				{
					$messageLog = "Pending || [SYSTEM] iPay88 Payment Pending. ".$Status_message.". Transaction Reference Number: " . $ipay88response->TransId;
				}

				$this->model_checkout_order->addOrderHistory($OrderNo, 1, $messageLog, false);
				
				$this->response->setOutput($this->load->view('payment/ipay88_success_backend'));
			}

			//Backend failed
			else {
				$this->response->setOutput($this->load->view('payment/ipay88_failure_backend'));
			}
		}
	}
}